diff --git a/oflog/include/dcmtk/oflog/clfsap.h b/oflog/include/dcmtk/oflog/clfsap.h
new file mode 100644
index 0000000..f525149
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/clfsap.h
@@ -0,0 +1,101 @@
+// -*- C++ -*-
+// Module:  Log4cplus
+// File:    clfsap.h
+// Created: 5/2012
+// Author:  Vaclav Zeman
+//
+//
+//  Copyright (C) 2012, Vaclav Zeman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+   
+ 
+//
+
+/** @file */
+
+#ifndef DCMTK_LOG4CPLUS_CLFSAPPENDER_H
+#define DCMTK_LOG4CPLUS_CLFSAPPENDER_H
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#include "dcmtk/oflog/appender.h"
+
+
+#if defined (DCMTK_LOG4CPLUS_CLFSAPPENDER_BUILD_DLL)
+#  if defined (INSIDE_DCMTK_LOG4CPLUS_CLFSAPPENDER)
+#    define DCMTK_LOG4CPLUS_CLFSAPPENDER_EXPORT __declspec(dllexport)
+#  else
+#    define DCMTK_LOG4CPLUS_CLFSAPPENDER_EXPORT __declspec(dllimport)
+#  endif
+#else
+#  define DCMTK_LOG4CPLUS_CLFSAPPENDER_EXPORT
+#endif
+
+
+namespace dcmtk
+{
+namespace log4cplus
+{
+
+
+class DCMTK_LOG4CPLUS_CLFSAPPENDER_EXPORT CLFSAppender
+    : public Appender
+{
+public:
+    CLFSAppender (tstring const & logname, unsigned long logsize,
+        unsigned long buffersize);
+    explicit CLFSAppender (helpers::Properties const &);
+    virtual ~CLFSAppender ();
+
+    virtual void close ();
+
+    static void registerAppender ();
+
+protected:
+    virtual void append (spi::InternalLoggingEvent const &);
+
+    void init (tstring const & logname, unsigned long logsize,
+        unsigned long buffersize);
+
+    struct Data;
+
+    Data * data;
+
+private:
+    CLFSAppender (CLFSAppender const &);
+    CLFSAppender & operator = (CLFSAppender const &);
+};
+
+
+typedef helpers::SharedObjectPtr<CLFSAppender> CLFSAppenderPtr;
+
+
+} // namespace log4cplus
+} // end namespace dcmtk
+
+
+#endif // DCMTK_LOG4CPLUS_CLFSAPPENDER_H
diff --git a/oflog/include/dcmtk/oflog/clogger.h b/oflog/include/dcmtk/oflog/clogger.h
new file mode 100644
index 0000000..9508dd0
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/clogger.h
@@ -0,0 +1,85 @@
+// -*- C -*-
+/**
+ * Module:  Log4CPLUS
+ * File:    clogger.h
+ * Created: 01/2011
+ * Author:  Jens Rehsack
+ *
+ *
+ * Copyright 2011 Jens Rehsack & Tad E. Smith
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+/** @file 
+ * This header defines the C API for log4cplus and the logging macros. */
+
+#ifndef DCMTK_LOG4CPLUS_CLOGGERHEADER_
+#define DCMTK_LOG4CPLUS_CLOGGERHEADER_
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+
+#ifdef __cplusplus
+extern "C"
+{
+#endif
+
+// TODO UNICDE capable
+
+typedef void *logger_t;
+typedef int loglevel_t;
+
+#define L4CP_OFF_LOG_LEVEL 60000
+#define L4CP_FATAL_LOG_LEVEL 50000
+#define L4CP_ERROR_LOG_LEVEL 40000
+#define L4CP_WARN_LOG_LEVEL 30000
+#define L4CP_INFO_LOG_LEVEL 20000
+#define L4CP_DEBUG_LOG_LEVEL 10000
+#define L4CP_TRACE_LOG_LEVEL 0
+#define L4CP_ALL_LOG_LEVEL TRACE_LOG_LEVEL
+#define L4CP_NOT_SET_LOG_LEVEL -1
+
+#ifdef UNICODE
+#  define DCMTK_LOG4CPLUS_TEXT2(STRING) L##STRING
+typedef wchar_t log4cplus_char_t;
+#else
+#  define DCMTK_LOG4CPLUS_TEXT2(STRING) STRING
+typedef char log4cplus_char_t;
+#endif // UNICODE
+#define DCMTK_LOG4CPLUS_TEXT(STRING) DCMTK_LOG4CPLUS_TEXT2(STRING)
+
+DCMTK_LOG4CPLUS_EXPORT int log4cplus_file_configure(const log4cplus_char_t *pathname);
+DCMTK_LOG4CPLUS_EXPORT int log4cplus_str_configure(const log4cplus_char_t *config);
+DCMTK_LOG4CPLUS_EXPORT int log4cplus_basic_configure(void);
+DCMTK_LOG4CPLUS_EXPORT void log4cplus_shutdown(void);
+
+DCMTK_LOG4CPLUS_EXPORT int log4cplus_logger_exists(const log4cplus_char_t *name);
+DCMTK_LOG4CPLUS_EXPORT int log4cplus_logger_is_enabled_for(
+    const log4cplus_char_t *name, loglevel_t ll);
+DCMTK_LOG4CPLUS_EXPORT int log4cplus_logger_log(const log4cplus_char_t *name,
+    loglevel_t ll, const log4cplus_char_t *msgfmt, ...)
+    DCMTK_LOG4CPLUS_FORMAT_ATTRIBUTE (__printf__, 3, 4);
+DCMTK_LOG4CPLUS_EXPORT int log4cplus_logger_force_log(const log4cplus_char_t *name,
+    loglevel_t ll, const log4cplus_char_t *msgfmt, ...)
+    DCMTK_LOG4CPLUS_FORMAT_ATTRIBUTE (__printf__, 3, 4);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /*?DCMTK_LOG4CPLUS_CLOGGERHEADER_*/
diff --git a/oflog/include/dcmtk/oflog/config.h b/oflog/include/dcmtk/oflog/config.h
index bf2aace..d2c8ee7 100644
--- a/oflog/include/dcmtk/oflog/config.h
+++ b/oflog/include/dcmtk/oflog/config.h
@@ -1,25 +1,25 @@
-//   Copyright (C) 2009, Vaclav Haisman. All rights reserved.
+//  Copyright (C) 2009-2010, Vaclav Haisman. All rights reserved.
 //
-//   Redistribution and use in source and binary forms, with or without modifica-
-//   tion, are permitted provided that the following conditions are met:
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
 //
-//   1. Redistributions of  source code must  retain the above copyright  notice,
-//      this list of conditions and the following disclaimer.
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
 //
-//   2. Redistributions in binary form must reproduce the above copyright notice,
-//      this list of conditions and the following disclaimer in the documentation
-//      and/or other materials provided with the distribution.
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
 //
-//   THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
-//   INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
-//   FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
-//   APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
-//   INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
-//   DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
-//   OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
-//   ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
-//   (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
-//   THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 #ifndef DCMTK_LOG4CPLUS_CONFIG_HXX
 #define DCMTK_LOG4CPLUS_CONFIG_HXX
@@ -28,6 +28,10 @@
 
 #include "dcmtk/ofstd/ofdefine.h"     /* We need DCMTK_DECL_EXPORT/_IMPORT */
 
+#ifdef oflog_EXPORTS
+#  define DCMTK_INSIDE_LOG4CPLUS
+#endif
+
 #if defined (_WIN32)
 #  include "dcmtk/oflog/config/win32.h"
 #elif (defined(__MWERKS__) && defined(__MACOS__))
@@ -36,25 +40,131 @@
 #  include "dcmtk/oflog/config/defines.h"
 #endif
 
+#if ! defined (UNICODE) && ! defined (DCMTK_LOG4CPLUS_HAVE_VSNPRINTF_S) \
+    && ! defined (DCMTK_LOG4CPLUS_HAVE__VSNPRINTF_S) \
+    && ! defined (DCMTK_LOG4CPLUS_HAVE_VSNPRINTF) \
+    && ! defined (DCMTK_LOG4CPLUS_HAVE__VSNPRINTF)
+#  undef DCMTK_LOG4CPLUS_USE_POOR_MANS_SNPRINTF
+#  define DCMTK_LOG4CPLUS_USE_POOR_MANS_SNPRINTF
+#endif
+
+# if ! defined (DCMTK_LOG4CPLUS_WORKING_LOCALE) \
+  && ! defined (DCMTK_LOG4CPLUS_WORKING_C_LOCALE) \
+  && ! defined (DCMTK_LOG4CPLUS_WITH_ICONV)
+# define DCMTK_LOG4CPLUS_POOR_MANS_CHCONV
+#endif
+
+#ifndef DCMTK_LOG4CPLUS_DECLSPEC_EXPORT
+#define DCMTK_LOG4CPLUS_DECLSPEC_EXPORT /* empty */
+#endif
+
+#ifndef DCMTK_LOG4CPLUS_DECLSPEC_IMPORT
+#define DCMTK_LOG4CPLUS_DECLSPEC_IMPORT /* empty */
+#endif
+
+#ifndef DCMTK_LOG4CPLUS_DECLSPEC_PRIVATE
+#define DCMTK_LOG4CPLUS_DECLSPEC_PRIVATE /* empty */
+#endif
+
+#define DCMTK_LOG4CPLUS_PRIVATE DCMTK_LOG4CPLUS_DECLSPEC_PRIVATE
+
 #if !defined(_WIN32)
+#  define DCMTK_LOG4CPLUS_USE_BSD_SOCKETS
 #  if !defined(DCMTK_LOG4CPLUS_SINGLE_THREADED)
 #    define DCMTK_LOG4CPLUS_USE_PTHREADS
 #  endif
 #  if defined (DCMTK_INSIDE_LOG4CPLUS)
-#    define DCMTK_LOG4CPLUS_EXPORT DCMTK_LOG4CPLUS_DECLSPEC_EXPORT
+#    define DCMTK_LOG4CPLUS_EXPORT DCMTK_DECL_EXPORT
 #  else
-#    define DCMTK_LOG4CPLUS_EXPORT DCMTK_LOG4CPLUS_DECLSPEC_IMPORT
+#    define DCMTK_LOG4CPLUS_EXPORT DCMTK_DECL_IMPORT
 #  endif // defined (DCMTK_INSIDE_LOG4CPLUS)
+
 #endif // !_WIN32
 
-#undef DCMTK_LOG4CPLUS_EXPORT
-#ifdef oflog_EXPORTS
-#define DCMTK_LOG4CPLUS_EXPORT DCMTK_DECL_EXPORT
+#if defined (DCMTK_LOG4CPLUS_INLINES_ARE_EXPORTED) \
+    && defined (DCMTK_LOG4CPLUS_BUILD_DLL)
+#  define DCMTK_LOG4CPLUS_INLINE_EXPORT inline
+#else
+#  define DCMTK_LOG4CPLUS_INLINE_EXPORT
+#endif
+
+#if defined (UNICODE)
+#  if defined (_MSC_VER) && _MSC_VER >= 1400
+#    define DCMTK_LOG4CPLUS_FSTREAM_ACCEPTS_WCHAR_T
+#  endif
+#  if defined (_MSC_VER) && _MSC_VER >= 1600
+#    define DCMTK_LOG4CPLUS_HAVE_CODECVT_UTF8_FACET
+#    define DCMTK_LOG4CPLUS_HAVE_CODECVT_UTF16_FACET
+#  endif
+#endif
+
+// C++11 stuff
+
+#if ! defined (__has_feature)
+//! __has_feature(X) is Clangs way for testing features.
+//! Define it to 0 if it does not exist.
+#  define __has_feature(X) 0
+#endif
+
+#if (defined (_MSC_VER) && _MSC_VER >= 1600) \
+    || defined (__GXX_EXPERIMENTAL_CXX0X__)
+#  define DCMTK_LOG4CPLUS_HAVE_CXX11_SUPPORT
+#endif
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_CXX11_SUPPORT) \
+    || __has_feature (cxx_rvalue_references)
+#  define DCMTK_LOG4CPLUS_HAVE_RVALUE_REFS
+#endif
+
+#if ! defined (UNICODE) && defined (__GNUC__) && __GNUC__ >= 3
+#  define DCMTK_LOG4CPLUS_FORMAT_ATTRIBUTE(archetype, format_index, first_arg_index) \
+    __attribute__ ((format (archetype, format_index, first_arg_index)))
 #else
-#define DCMTK_LOG4CPLUS_EXPORT DCMTK_DECL_IMPORT
+#  define DCMTK_LOG4CPLUS_FORMAT_ATTRIBUTE(archetype, fmt_index, first_arg_index) \
+    /* empty */
+#endif
+
+#if defined (__GNUC__) && __GNUC__ >= 3
+#  define DCMTK_LOG4CPLUS_ATTRIBUTE_NORETURN __attribute__ ((__noreturn__))
+#  define DCMTK_LOG4CPLUS_ATTRIBUTE_PURE __attribute__ ((__pure__))
+#  define DCMTK_LOG4CPLUS_BUILTIN_EXPECT(exp, c) __builtin_expect ((exp), (c))
+#else
+#  define DCMTK_LOG4CPLUS_ATTRIBUTE_NORETURN /* empty */
+#  define DCMTK_LOG4CPLUS_ATTRIBUTE_PURE /* empty */
+#  define DCMTK_LOG4CPLUS_BUILTIN_EXPECT(exp, c) (exp)
+#endif
+
+#define DCMTK_LOG4CPLUS_LIKELY(cond) DCMTK_LOG4CPLUS_BUILTIN_EXPECT(!! (cond), 1)
+#define DCMTK_LOG4CPLUS_UNLIKELY(cond) DCMTK_LOG4CPLUS_BUILTIN_EXPECT(!! (cond), 0)
+
+#if defined (_MSC_VER)                                             \
+    || (defined (__COMO__) && __COMO_VERSION__ >= 400) /* ??? */   \
+    || (defined (__DMC__) && __DMC__ >= 0x700) /* ??? */           \
+    || (defined (__clang__) && __clang_major__ >= 3)               \
+    || (defined (__GNUC__) && (__GNUC__ >= 4                       \
+            || (__GNUC__ == 3 && __GNUC_MINOR__ >= 4)))
+#  define DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE
+#  pragma once
 #endif
 
 #include "dcmtk/oflog/helpers/threadcf.h"
 
+#if defined(__cplusplus)
+namespace dcmtk
+{
+namespace log4cplus
+{
+
+//! Per thread cleanup function. Users should call this function before
+//! a thread ends its execution. It frees resources allocated in thread local
+//! storage. It is important only for multi-threaded static library builds
+//! of log4cplus and user threads. In all other cases the clean up is provided
+//! automatically by other means.
+DCMTK_LOG4CPLUS_EXPORT void threadCleanup ();
+
+} // namespace log4cplus
+} // end namespace dcmtk
+
+#endif
 
 #endif // DCMTK_LOG4CPLUS_CONFIG_HXX
diff --git a/oflog/include/dcmtk/oflog/config/defines.h b/oflog/include/dcmtk/oflog/config/defines.h
index 7220884..1fe5681 100644
--- a/oflog/include/dcmtk/oflog/config/defines.h
+++ b/oflog/include/dcmtk/oflog/config/defines.h
@@ -1,3 +1,5 @@
+// TODO: Make sure our configure machinery actually defines all of these
+
 #ifndef DCMTK_LOG4CPLUS_CONFIG_DEFINES_HXX
 #define DCMTK_LOG4CPLUS_CONFIG_DEFINES_HXX
 
@@ -7,16 +9,56 @@
 #endif
 
 /* */
+#ifdef HAVE_ARPA_INET_H
+#define DCMTK_LOG4CPLUS_HAVE_ARPA_INET_H
+#endif
+
+/* */
 #ifdef HAVE_NETINET_IN_H
 #define DCMTK_LOG4CPLUS_HAVE_NETINET_IN_H
 #endif
 
 /* */
+#ifdef HAVE_NETINET_TCP_H
+#define DCMTK_LOG4CPLUS_HAVE_NETINET_TCP_H
+#endif
+
+/* */
+#ifdef HAVE_SYS_TIMEB_H
+#define DCMTK_LOG4CPLUS_HAVE_SYS_TIMEB_H
+#endif
+
+/* */
+#ifdef HAVE_SYS_TIME_H
+#define DCMTK_LOG4CPLUS_HAVE_SYS_TIME_H
+#endif
+
+/* */
 #ifdef HAVE_SYS_TYPES_H
 #define DCMTK_LOG4CPLUS_HAVE_SYS_TYPES_H
 #endif
 
 /* */
+#ifdef HAVE_SYS_STAT_H
+#define DCMTK_LOG4CPLUS_HAVE_SYS_STAT_H
+#endif
+
+/* */
+#ifdef HAVE_SYS_SYSCALL_H
+#define DCMTK_LOG4CPLUS_HAVE_SYS_SYSCALL_H
+#endif
+
+/* */
+#ifdef HAVE_SYS_FILE_H
+#define DCMTK_LOG4CPLUS_HAVE_SYS_FILE_H
+#endif
+
+/* */
+#ifdef HAVE_TIME_H
+#define DCMTK_LOG4CPLUS_HAVE_TIME_H
+#endif
+
+/* */
 #ifdef HAVE_SYS_SOCKET_H
 #define DCMTK_LOG4CPLUS_HAVE_SYS_SOCKET_H
 #endif
@@ -32,6 +74,41 @@
 #endif
 
 /* */
+#ifdef HAVE_FCNTL_H
+#define DCMTK_LOG4CPLUS_HAVE_FCNTL_H
+#endif
+
+/* */
+#ifdef HAVE_STDARG_H
+#define DCMTK_LOG4CPLUS_HAVE_STDARG_H
+#endif
+
+/* */
+#ifdef HAVE_STDIO_H
+#define DCMTK_LOG4CPLUS_HAVE_STDIO_H
+#endif
+
+/* */
+#ifdef HAVE_STDLIB_H
+#define DCMTK_LOG4CPLUS_HAVE_STDLIB_H
+#endif
+
+/* */
+#ifdef HAVE_ERRNO_H
+#define DCMTK_LOG4CPLUS_HAVE_ERRNO_H
+#endif
+
+/* */
+#ifdef HAVE_WCHAR_H
+#define DCMTK_LOG4CPLUS_HAVE_WCHAR_H
+#endif
+
+/* */
+#ifdef HAVE_LIMITS_H
+#define DCMTK_LOG4CPLUS_HAVE_LIMITS_H
+#endif
+
+/* */
 #ifdef HAVE_FTIME
 #define DCMTK_LOG4CPLUS_HAVE_FTIME
 #endif
@@ -42,6 +119,11 @@
 #endif
 
 /* */
+#ifdef HAVE_GETHOSTBYNAME_R
+#define DCMTK_LOG4CPLUS_HAVE_GETHOSTBYNAME_R
+#endif
+
+/* */
 #ifdef HAVE_GETPID
 #define DCMTK_LOG4CPLUS_HAVE_GETPID
 #endif
@@ -51,6 +133,21 @@
 #define DCMTK_LOG4CPLUS_HAVE_GETTIMEOFDAY
 #endif
 
+/* Define to 1 if you have the `clock_gettime' function. */
+#ifdef HAVE_PROTOTYPE_CLOCK_GETTIME
+#define DCMTK_LOG4CPLUS_HAVE_CLOCK_GETTIME
+#endif
+
+/* Define to 1 if you have the `nanosleep' function. */
+#ifdef HAVE_NANOSLEEP
+#define DCMTK_LOG4CPLUS_HAVE_NANOSLEEP
+#endif
+
+/* Define to 1 if you have the `clock_nanosleep' function. */
+#ifdef HAVE_CLOCK_NANOSLEEP
+#define DCMTK_LOG4CPLUS_HAVE_CLOCK_NANOSLEEP
+#endif
+
 /* */
 #ifdef HAVE_GMTIME_R
 #define DCMTK_LOG4CPLUS_HAVE_GMTIME_R
@@ -77,6 +174,21 @@
 #endif
 
 /* */
+#ifdef HAVE_FCNTL
+#define DCMTK_LOG4CPLUS_HAVE_FCNTL
+#endif
+
+/* */
+#ifdef HAVE_LOCKF
+#define DCMTK_LOG4CPLUS_HAVE_LOCKF
+#endif
+
+/* */
+#ifdef HAVE_FLOCK
+#define DCMTK_LOG4CPLUS_HAVE_FLOCK
+#endif
+
+/* */
 #ifdef HAVE_NTOHL
 #define DCMTK_LOG4CPLUS_HAVE_NTOHL
 #endif
@@ -103,6 +215,10 @@
    locale. */
 #undef DCMTK_LOG4CPLUS_WORKING_LOCALE
 
+/* Define for C99 compilers/standard libraries that support more than just the
+   "C" locale. */
+#undef DCMTK_LOG4CPLUS_WORKING_C_LOCALE
+
 /* Define to int if undefined. */
 #if 0
 /* This block is handled by configure completely */
@@ -118,14 +234,129 @@
 #endif
 
 /* These two are not needed since we build static libraries */
-/* Defined if the compiler understands __declspec(export) or __attribute__((export)) construct. */
+/* Defined if the compiler understands __declspec(dllexport) or
+   __attribute__((visibility("default"))) construct. */
 #define DCMTK_LOG4CPLUS_DECLSPEC_EXPORT
-/* Defined if the compiler understands __declspec(import) or __attribute__((import)) construct. */
+
+/* Defined if the compiler understands __declspec(dllimport) or
+   __attribute__((visibility("default"))) construct. */
 #define DCMTK_LOG4CPLUS_DECLSPEC_IMPORT
 
+/* Defined if the compiler understands
+   __attribute__((visibility("hidden"))) construct. */
+#define DCMTK_LOG4CPLUS_DECLSPEC_PRIVATE
+
+/* */
+#define DCMTK_LOG4CPLUS_HAVE_TLS_SUPPORT
+
+/* */
+#define DCMTK_LOG4CPLUS_THREAD_LOCAL_VAR
+
 /* Defined if the host OS provides ENAMETOOLONG errno value. */
 #ifdef HAVE_ENAMETOOLONG
 #define DCMTK_LOG4CPLUS_HAVE_ENAMETOOLONG
 #endif
 
+/* Defined if the compiler provides __sync_add_and_fetch(). */
+#ifdef HAVE_SYNC_ADD_AND_FETCH
+#define DCMTK_LOG4CPLUS_HAVE___SYNC_ADD_AND_FETCH
+#endif
+
+/* Defined if the compiler provides __sync_sub_and_fetch(). */
+#ifdef HAVE_SYNC_SUB_AND_FETCH
+#define DCMTK_LOG4CPLUS_HAVE___SYNC_SUB_AND_FETCH
+#endif
+
+/* Defined if the compiler provides C++11 <atomic> header and increment,
+   decrement operations. */
+#ifdef HAVE_CXX11_ATOMICS
+#define DCMTK_LOG4CPLUS_HAVE_CXX11_ATOMICS
+#endif
+
+/* */
+#ifdef HAVE_C99_VARIADIC_MACROS
+#define DCMTK_LOG4CPLUS_HAVE_C99_VARIADIC_MACROS
+#endif
+
+/* */
+#ifdef HAVE_GNU_VARIADIC_MACROS
+#define DCMTK_LOG4CPLUS_HAVE_GNU_VARIADIC_MACROS
+#endif
+
+/* */
+#ifdef HAVE_VSNPRINTF
+#define DCMTK_LOG4CPLUS_HAVE_VSNPRINTF
+#endif
+
+/* */
+#ifdef HAVE_PROTOTYPE_STD__VSNPRINTF
+#define DCMTK_LOG4CPLUS_HAVE__VSNPRINTF
+#endif
+
+/* Define to 1 if you have the `vfprintf_s' function. */
+#ifdef HAVE_VFPRINTF_S
+#define DCMTK_LOG4CPLUS_HAVE_VFPRINTF_S
+#endif
+
+/* Define to 1 if you have the `vfwprintf_s' function. */
+#ifdef HAVE_VFWPRINTF_S
+#define DCMTK_LOG4CPLUS_HAVE_VFWPRINTF_S
+#endif
+
+/* Define to 1 if you have the `vsprintf_s' function. */
+#ifdef HAVE_VSPRINTF_S
+#define DCMTK_LOG4CPLUS_HAVE_VSPRINTF_S
+#endif
+
+/* Define to 1 if you have the `vswprintf_s' function. */
+#ifdef HAVE_VSWPRINTF_S
+#define DCMTK_LOG4CPLUS_HAVE_VSWPRINTF_S
+#endif
+
+/* Define to 1 if you have the `_vsnprintf_s' function. */
+#ifdef HAVE__VSNPRINTF_S
+#define DCMTK_LOG4CPLUS_HAVE__VSNPRINTF_S
+#endif
+
+/* Define to 1 if you have the `_vsnwprintf_s' function. */
+#ifdef HAVE__VSNWPRINTF_S
+#define DCMTK_LOG4CPLUS_HAVE__VSNWPRINTF_S
+#endif
+
+/* Defined if the compiler supports __FUNCTION__ macro. */
+#ifdef HAVE___FUNCTION___MACRO
+#define DCMTK_LOG4CPLUS_HAVE_FUNCTION_MACRO
+#endif
+
+/* Defined if the compiler supports __PRETTY_FUNCTION__ macro. */
+#ifdef HAVE___PRETTY_FUNCTION___MACRO
+#define DCMTK_LOG4CPLUS_HAVE_PRETTY_FUNCTION_MACRO
+#endif
+
+/* Defined if the compiler supports __func__ symbol. */
+#ifdef HAVE___func___MACRO
+#define DCMTK_LOG4CPLUS_HAVE_FUNC_SYMBOL
+#endif
+
+/* Define to 1 if you have the `mbstowcs' function. */
+#ifdef HAVE_MBSTOWCS
+#define DCMTK_LOG4CPLUS_HAVE_MBSTOWCS
+#endif
+
+/* Define to 1 if you have the `wcstombs' function. */
+#ifdef HAVE_WCSTOMBS
+#define DCMTK_LOG4CPLUS_HAVE_WCSTOMBS
+#endif
+
+/* Define to 1 if you have Linux style syscall(SYS_gettid). */
+#ifdef HAVE_SYS_SYSCALL_H
+#define DCMTK_LOG4CPLUS_HAVE_GETTID
+#endif
+
+/* Define when iconv() is available. */
+#ifdef WITH_LIBICONV
+#define DCMTK_LOG4CPLUS_WITH_ICONV
+#define DCMTK_LOG4CPLUS_HAVE_ICONV_H
+#endif
+
 #endif // DCMTK_LOG4CPLUS_CONFIG_DEFINES_HXX
diff --git a/oflog/include/dcmtk/oflog/config/macosx.h b/oflog/include/dcmtk/oflog/config/macosx.h
index 63c9e4b..a61ab27 100644
--- a/oflog/include/dcmtk/oflog/config/macosx.h
+++ b/oflog/include/dcmtk/oflog/config/macosx.h
@@ -1,21 +1,33 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    config-macosx.h
 // Created: 7/2003
 // Author:  Christopher R. Bailey
 //
 //
-// Copyright (C) Tad E. Smith  All rights reserved.
+// Copyright 2003-2010 Christopher R. Bailey
 //
-// This software is published under the terms of the Apache Software
-// License version 1.1, a copy of which has been included with this
-// distribution in the LICENSE.APL file.
+// Licensed under the Apache License, Version 2.0 (the "License");
+// you may not use this file except in compliance with the License.
+// You may obtain a copy of the License at
 //
+//     http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software
+// distributed under the License is distributed on an "AS IS" BASIS,
+// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+// See the License for the specific language governing permissions and
+// limitations under the License.
 
 /** @file */
 
 #ifndef DCMTK_LOG4CPLUS_CONFIG_MACOSX_HEADER_
 #define DCMTK_LOG4CPLUS_CONFIG_MACOSX_HEADER_
 
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #if (defined(__APPLE__) || (defined(__MWERKS__) && defined(__MACOS__)))
 
 #define DCMTK_LOG4CPLUS_HAVE_GETTIMEOFDAY 1
diff --git a/oflog/include/dcmtk/oflog/config/win32.h b/oflog/include/dcmtk/oflog/config/win32.h
index 1ea5d8c..5f2eba5 100644
--- a/oflog/include/dcmtk/oflog/config/win32.h
+++ b/oflog/include/dcmtk/oflog/config/win32.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    config-win32.h
 // Created: 4/2003
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -23,41 +24,141 @@
 #ifndef DCMTK_LOG4CPLUS_CONFIG_WIN32_HEADER_
 #define DCMTK_LOG4CPLUS_CONFIG_WIN32_HEADER_
 
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #ifdef _WIN32
-#include <windows.h>
 
-/* Define if you have the ftime function.  */
-#define DCMTK_LOG4CPLUS_HAVE_FTIME 1
+#if (defined (_MSC_VER) && _MSC_VER >= 1400) || defined (__MINGW32__)
+#  define DCMTK_LOG4CPLUS_HAVE_INTRIN_H
+#endif
 
-#if defined (_WIN32_WCE)
-#  define DCMTK_LOG4CPLUS_DLLMAIN_HINSTANCE HANDLE
-#  undef DCMTK_LOG4CPLUS_HAVE_NT_EVENT_LOG
-#else
-#  define DCMTK_LOG4CPLUS_DLLMAIN_HINSTANCE HINSTANCE
-#  define DCMTK_LOG4CPLUS_HAVE_NT_EVENT_LOG
-#  define DCMTK_LOG4CPLUS_HAVE_WIN32_CONSOLE
+// Time related functions and headers.
+#define DCMTK_LOG4CPLUS_HAVE_TIME_H
+#define DCMTK_LOG4CPLUS_HAVE_SYS_TIMEB_H
+#define DCMTK_LOG4CPLUS_HAVE_FTIME
+#if defined (_MSC_VER) || defined (__BORLANDC__) 
+#define DCMTK_LOG4CPLUS_HAVE_GMTIME_S
+#endif
+
+// Use Winsock on Windows.
+#define DCMTK_LOG4CPLUS_USE_WINSOCK
+
+// Enable Win32DebugAppender
+#define DCMTK_LOG4CPLUS_HAVE_OUTPUTDEBUGSTRING
+
+// Enable Win32ConsoleAppender.
+#define DCMTK_LOG4CPLUS_HAVE_WIN32_CONSOLE
+
+#define DCMTK_LOG4CPLUS_HAVE_SYS_TYPES_H
+#define DCMTK_LOG4CPLUS_HAVE_SYS_LOCKING_H
+#define DCMTK_LOG4CPLUS_HAVE_FCNTL_H
+#define DCMTK_LOG4CPLUS_HAVE_IO_H
+#define DCMTK_LOG4CPLUS_HAVE_STDIO_H
+#define DCMTK_LOG4CPLUS_HAVE_WCHAR_H
+#define DCMTK_LOG4CPLUS_HAVE_STDARG_H
+#define DCMTK_LOG4CPLUS_HAVE_STDLIB_H
+#define DCMTK_LOG4CPLUS_HAVE_ERRNO_H
+#define DCMTK_LOG4CPLUS_HAVE_SYS_STAT_H
+#define DCMTK_LOG4CPLUS_HAVE_TIME_H
+#define DCMTK_LOG4CPLUS_HAVE_STDLIB_H
+
+// MSVC has both and so does MinGW.
+#define DCMTK_LOG4CPLUS_HAVE_VSNPRINTF
+#define DCMTK_LOG4CPLUS_HAVE__VSNPRINTF
+#if _MSC_VER <= 1200 /* Additional settings for VC6 and older */
+#undef DCMTK_LOG4CPLUS_HAVE_VSNPRINTF
+#endif
+
+#if defined (_MSC_VER) || defined (__MINGW32__)
+// MS secure versions of vprintf().
+#  define DCMTK_LOG4CPLUS_HAVE_VSPRINTF_S
+#  define DCMTK_LOG4CPLUS_HAVE_VSWPRINTF_S
+
+// MS secure versions of vfprintf().
+#  define DCMTK_LOG4CPLUS_HAVE_VFPRINTF_S
+#  define DCMTK_LOG4CPLUS_HAVE_VFWPRINTF_S
+
+// MS secure versions of vsnprintf().
+#  define DCMTK_LOG4CPLUS_HAVE_VSNPRINTF_S
+#  define DCMTK_LOG4CPLUS_HAVE__VSNPRINTF_S
+#  define DCMTK_LOG4CPLUS_HAVE__VSNWPRINTF_S
+#endif
+
+#define DCMTK_LOG4CPLUS_DLLMAIN_HINSTANCE HINSTANCE
+#define DCMTK_LOG4CPLUS_HAVE_NT_EVENT_LOG
+
+// log4cplus_EXPORTS is used by the CMake build system.  DLL_EXPORT is
+// used by the autotools build system.
+#if (defined (log4cplus_EXPORTS) || defined (log4cplusU_EXPORTS) \
+     || defined (DLL_EXPORT))                                    \
+    && ! defined (DCMTK_LOG4CPLUS_STATIC)
+#  undef DCMTK_LOG4CPLUS_BUILD_DLL
+#  define DCMTK_LOG4CPLUS_BUILD_DLL
+#endif
+
+#if ! defined (DCMTK_LOG4CPLUS_BUILD_DLL)
+#  undef DCMTK_LOG4CPLUS_STATIC
+#  define DCMTK_LOG4CPLUS_STATIC
+#endif
+
+#if defined (DCMTK_LOG4CPLUS_STATIC) && defined (DCMTK_LOG4CPLUS_BUILD_DLL)
+#  error DCMTK_LOG4CPLUS_STATIC and DCMTK_LOG4CPLUS_BUILD_DLL cannot be defined both.
 #endif
 
-// This was moved to config.h
-//#define DCMTK_LOG4CPLUS_EXPORT
+#if defined (DCMTK_LOG4CPLUS_BUILD_DLL)
+#  if defined (DCMTK_INSIDE_LOG4CPLUS)
+#    define DCMTK_LOG4CPLUS_EXPORT __declspec(dllexport)
+#  else
+#    define DCMTK_LOG4CPLUS_EXPORT __declspec(dllimport)
+#  endif
+#else
+#  define DCMTK_LOG4CPLUS_EXPORT
+#endif
 
 #ifndef DCMTK_LOG4CPLUS_SINGLE_THREADED
 #  define DCMTK_LOG4CPLUS_USE_WIN32_THREADS
 #endif
 
+#if defined (_WIN32_WINNT) && _WIN32_WINNT < 0x0600
+#  define DCMTK_LOG4CPLUS_POOR_MANS_SHAREDMUTEX
+#endif
+
 #if defined(_MSC_VER)
   // Warning about: identifier was truncated to '255' characters in the debug information
 #  pragma warning( disable : 4786 )
   // Warning about: <type1> needs to have dll-interface to be used by clients of class <type2>
 #  pragma warning( disable : 4251 )
 
+#  define DCMTK_LOG4CPLUS_INLINES_ARE_EXPORTED
+
 #  if _MSC_VER >= 1400
 #    define DCMTK_LOG4CPLUS_WORKING_LOCALE
+#    define DCMTK_LOG4CPLUS_HAVE_FUNCTION_MACRO
+#    define DCMTK_LOG4CPLUS_HAVE_FUNCSIG_MACRO
+#    define DCMTK_LOG4CPLUS_HAVE_C99_VARIADIC_MACROS
 #  endif
+#endif
 
+#if defined (__GNUC__)
+#  undef DCMTK_LOG4CPLUS_INLINES_ARE_EXPORTED
+#  if __GNUC__ > 4 || (__GNUC__ == 4 && __GNUC_MINOR__ >= 5)
+#    define DCMTK_LOG4CPLUS_INLINES_ARE_EXPORTED
+#    define DCMTK_LOG4CPLUS_HAVE___SYNC_SUB_AND_FETCH
+#    define DCMTK_LOG4CPLUS_HAVE___SYNC_ADD_AND_FETCH
+#  endif
+#  define DCMTK_LOG4CPLUS_HAVE_FUNCTION_MACRO
+#  define DCMTK_LOG4CPLUS_HAVE_GNU_VARIADIC_MACROS
+#  define DCMTK_LOG4CPLUS_HAVE_C99_VARIADIC_MACROS
+#  if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 4)
+#    define DCMTK_LOG4CPLUS_HAVE_PRETTY_FUNCTION_MACRO
+#  endif
+#  if defined (__MINGW32__)
+#    define DCMTK_LOG4CPLUS_WORKING_C_LOCALE
+#  endif
 #endif
 
 
 #endif // _WIN32
 #endif // DCMTK_LOG4CPLUS_CONFIG_WIN32_HEADER_
-
